#ifndef MESH_H
#define MESH_H

#include <stdio.h>
#include <vector>
#include "GLSL.h"
#include "tiny_obj_loader.h"
using namespace std;

class Mesh {
	vector<tinyobj::shape_t> _shapes;
	vector<tinyobj::material_t> _materials;

	GLuint _posBufObj;
	GLuint _norBufObj;
	GLuint _indBufObj;
	GLuint _transBufObj;

public:
	Mesh() {}
	Mesh(const string &objFile);

	vector<float> posBuf;
	vector<float> norBuf;
	vector<unsigned int> indBuf;

	void loadObject(const string &objFile);
	void loadObject(vector<float> positions, vector<float> normals, vector<unsigned int> indices);

	int useMesh(GLuint aPos);
	int useMesh(GLuint aPos, GLuint aNor);

	GLuint posBufObj() { return _posBufObj; }
	GLuint norBufObj() { return _norBufObj; }
	GLuint indBufObj() { return _indBufObj; }

	unsigned int indices() { return indBuf.size(); }

private:
	void resize_obj();
	void loadShapes(const string &objFile);
	void generateNormals();
};

#endif