#ifndef INSTANCE_TYPES_H
#define INSTANCE_TYPES_H

// Ground Plane
#define FLOOR 0.0f
#define PLANE_INFINITY 500.0f

// Fire Characteristics
#define FLAME_PARTICLE_COUNT 31
#define FLAME_COUNT 42
#define MAX_FIRE_SWAY 0.1f
#define FIRE_SPREAD 0.2f // Distance between match/candle for fire spreading

// Tree Characteristics
#define TREE_COUNT 330
#define PLANE_TREES 300.0f

// Altar Characteristics
#define ALTAR_SIZE 10.0f
#define ALTAR_HEIGHT 2.0f
#define ALTAR_POS vec3(0.0f, 0.0f, 100.0f)

typedef struct point_light
{
	vec3 Color;
	float AmbIntensity;
	float DifIntensity;
	float SpeIntensity;
	float SpePower;

    vec3 Position;
	vec3 Attenuation;
} PointLight;

typedef struct fire_light
{
	PointLight source;
	int lit;
	vec3 outsideColor;
	float life[FLAME_PARTICLE_COUNT];
	vec3 sway[FLAME_PARTICLE_COUNT];
} Fire;

typedef struct tree_loc
{
	vec3 Position;
	float rotation;
	float size;
} Tree;

#endif