// Michael Granneman

#include <stdio.h>
#include <string>
#include <vector>
#include <iostream>
#include <fstream>
#include <algorithm>
using namespace std;

#include <stdlib.h>
#include <string.h>

#include <direct.h>

#include <GL/glew.h>

#include "load_shader.hpp"

// Open, compile, and check a shader of type |shader_type|
// Does not link the shader into a program - just returns the compiled shader's ID
// ADAPTED FROM SHADER.CPP FROM OPENGL-TUTORIALS.ORG
GLuint LoadShader(std::string file_path, GLuint shader_type) {
	// Create the shader
	GLuint ShaderID = glCreateShader(shader_type);

	// Read the Shader code from the file
	std::string ShaderCode;
	std::ifstream ShaderStream(file_path.c_str(), std::ios::in);
	if(ShaderStream.is_open()) {
		std::string Line = "";
		while(getline(ShaderStream, Line))
			ShaderCode += "\n" + Line;
		ShaderStream.close();
	} else {
		printf("Impossible to open %s. Are you in the right directory ? Don't forget to read the FAQ !\n", file_path.c_str());
		getchar();
		return 0;
	}

	GLint Result = GL_FALSE;
	int InfoLogLength;

	// Compile Shader
	printf("Compiling shader: %s\n", file_path.c_str());
	char const * SourcePointer = ShaderCode.c_str();
	glShaderSource(ShaderID, 1, &SourcePointer , NULL);
	glCompileShader(ShaderID);

	// Check Shader
	glGetShaderiv(ShaderID, GL_COMPILE_STATUS, &Result);
	glGetShaderiv(ShaderID, GL_INFO_LOG_LENGTH, &InfoLogLength);
	if ( InfoLogLength > 0 ) {
		std::vector<char> ShaderErrorMessage(InfoLogLength+1);
		glGetShaderInfoLog(ShaderID, InfoLogLength, NULL, &ShaderErrorMessage[0]);
		printf("%s\n", &ShaderErrorMessage[0]);
	}

	return ShaderID;
}