#version 330 core

layout (location = 0) out vec3 FragmentColor;

uniform sampler2D image;
uniform sampler2D depth;

uniform float offset[3] = float[]( 0.0, 1.3846153846, 3.2307692308 );
uniform float weight[3] = float[]( 0.2270270270, 0.3162162162, 0.0702702703 );

uniform vec2 uSize;
uniform float radius;
uniform int dof;
uniform float zFar;

void main(void)
{
	float blurRad = radius;
	if (dof == 1) {
		blurRad *= texture2D( depth, vec2(gl_FragCoord)/uSize ).z / zFar;
	}
	FragmentColor = texture2D( image, vec2(gl_FragCoord)/uSize ).xyz * weight[0];
	for (int i=1; i<3; i++) {
		FragmentColor += texture2D( image, ( vec2(gl_FragCoord)+vec2(blurRad * offset[i], 0.0) )/uSize ).xyz * weight[i];
		FragmentColor += texture2D( image, ( vec2(gl_FragCoord)-vec2(blurRad * offset[i], 0.0) )/uSize ).xyz * weight[i];
	}
}
