#version 330

in vec3 vNormal;
in vec3 vPos;

out vec4 FragColor;

uniform vec3 colCenter;
uniform vec3 colOutside;

uniform float alphaFactor;

void main()
{
	float factor = pow(max(dot(normalize(vNormal), -normalize(vPos)), 0.0), 2.0);
	FragColor = factor * vec4(colCenter, 0.6) + (1 - factor) * vec4(colOutside, 0.0);
	FragColor.a *= alphaFactor;
}
