#version 330

layout (location = 0) in vec3 aPos;                                             
layout (location = 1) in vec3 aNor;   

uniform mat4 M;
uniform mat4 V;
uniform mat4 P;
uniform mat4 N;

out vec3 vNormal;
out vec3 vPos;

void main()
{

	gl_Position = (P * V * M) * vec4(aPos, 1.0);
	vec4 vPos4 = (V * M * vec4(aPos, 1.0));
	
	vPos = vPos4.xyz / vPos4.w;

	vNormal = vec3(N * vec4(aNor, 0.0));
}
